// p009.cpp : Defines the entry point for the console application.
//

#include "StdAfx.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "glut.h"

#define KRYCHLE_A 0.1f
#define POHYB 0.8f
#define POLOMER 0.4
#define PI 3.141592654
#define SQRT2 0.7071067812

enum  
{ PERSPEKTIVA, ROVNOBEZNE_PROMITANI } mod = ROVNOBEZNE_PROMITANI ;

float	r, draha=0.0, rotace=0.0, spirala_z=-1.0,spirala_uhel=0.0, osmicka_uhel=0.0, krychleuhel=0.0;
double kamera=0;
int smer_pohybu=0, konst=1, g=1, kam=0;


void setProjection(void)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	switch (mod) {
	case (PERSPEKTIVA):
		gluPerspective(70, 1, 0.01, 110); 
		gluLookAt(1.7*cos(kamera),1.7*sin(kamera),1.0, 0,0,0, 0,0,2);
		break;
	case (ROVNOBEZNE_PROMITANI):
         glOrtho(-1.0,1.0,-1.0,1.0,-20.0,20.0);
		break;
	}
	glMatrixMode(GL_MODELVIEW);
}


void init(void)
{
  static GLfloat svetlo[4] = { 20, 20, 10, 10 };
  GLfloat position[4];

GLfloat LightAmbient[]=		{ 0.2f, 0.2f, 0.2f, 1.0f };
GLfloat LightDiffuse[]=		{ 0.5f, 0.5f, 0.5f, 1.0f };
GLfloat LightPosition[]=	{ 0.0f, 0.0f, 0.5f, 1.0f };


  glShadeModel(GL_SMOOTH);
  glClearColor(0.0f, 0.0f, 0.0f, 0.5f);
  glClearDepth(1.0f);				
  glEnable(GL_DEPTH_TEST);			
  glDepthFunc(GL_LEQUAL);			
  glEnable ( GL_COLOR_MATERIAL );
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
  glEnable(GL_LIGHTING);
  glShadeModel(GL_SMOOTH);
  glEnable(GL_DEPTH_TEST);	
  glEnable(GL_COLOR_MATERIAL);
  glEnable(GL_LIGHTING);

  glTranslatef(3.0,2.0,0.0);
  glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);
  glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);
  glEnable(GL_LIGHT1);

}

void display(void)
{

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  setProjection();
  int i;

  glLoadIdentity();
  glPushMatrix();

  glColorMaterial(GL_FRONT, GL_EMISSION);
  glColor3f(0.4,0.3,1.0);  
  glBegin(GL_POLYGON);
	glVertex3f(0.0,1.0,0.0);
	glVertex3f(SQRT2,SQRT2,0.0);
	glVertex3f(1.0,0.0,0.0);
	glVertex3f(SQRT2,-SQRT2,0.0);
	glVertex3f(0.0,-1.0,0.0);
	glVertex3f(-SQRT2,-SQRT2,0.0);
	glVertex3f(-1.0,0.0,0.0);
	glVertex3f(-SQRT2,SQRT2,0.0);
  glEnd();
 
  
  
  if (krychleuhel>=360) krychleuhel=0;
  krychleuhel+=0.1;
  glTranslatef(0.0,0.0,0.4); /*kreslim krychle na vrcholy*/ 
  glRotatef(krychleuhel,0.0,1.0,0.0);
  for (i=0; i<8; i++) {	  
	glRotatef(45,0.0,1.0,0.0);
	/*glPushMatrix();*/
    glTranslatef(0.26,0.0,0.0);
    glColor3f(1.0,0.0,0.0);
	glColorMaterial(GL_FRONT, GL_EMISSION);
    glutSolidCube(0.2);
    //glPopMatrix();
	glTranslatef(-0.26,0.0,0.0);
  }




  glLoadIdentity();

  if (kamera>2*PI) kamera=0;
  else kamera+=0.003;


  glTranslatef(-0.65,-0.3,0.0);
  glRotatef(45,1.0,1.0,0.0);

  switch (kam) {
		case 0:
			glTranslatef(draha, draha, 0.0);
			break;
		case 1:
			glTranslatef(POHYB,POHYB-draha, draha);
			break;
		case 2:
			glTranslatef(POHYB-draha,0.0,POHYB-draha);
			break;
  }

  if (draha>POHYB) {
	  if (rotace<360.0) {
		glRotatef(rotace,0.0,1.0,1.0);
		rotace+=0.5;
	  }
	  else {
		  kam=(kam+1)%3;
		  draha=0.0;
		  rotace=0.0;
	  }
  }
  else 	draha+=0.003;

  glColor3f(0.0,0.0,1.0);
  glutSolidCone(0.1,0.15,8,2);

  glLoadIdentity();


    if (spirala_uhel >= 2*PI)
		spirala_uhel = 0;
	if (smer_pohybu==0)
		if (spirala_z<0.8) spirala_z+=0.001;
		else smer_pohybu=1;
	else 
		if (spirala_z>-0.8) spirala_z-=0.001;
		else smer_pohybu=0;
	
	spirala_uhel+=0.01;

	glTranslatef(POLOMER*cos(spirala_uhel),POLOMER*sin(spirala_uhel),spirala_z);
	glColor3f(0.3,0.8,0.0);
    glColorMaterial(GL_FRONT, GL_EMISSION);
	glutSolidSphere(0.1,40,40);


// osmicka
    glLoadIdentity();

	if (g<0) {
		glTranslatef(0.35,0.0,0.4);
        if (osmicka_uhel<=-PI) {glTranslatef(-0.7,0.0,0.0);osmicka_uhel=0; g=-g;}
		osmicka_uhel-=0.01;
	}
	else {
		glTranslatef(-0.35,0.0,0.4); 
        if (osmicka_uhel>=2*PI) {glTranslatef(0.7,0.0,0.0);osmicka_uhel=PI; g=-1;}
   		osmicka_uhel+=0.01;
	}
	glTranslatef(0.35*konst*cos(osmicka_uhel), 0.35*konst*sin(osmicka_uhel), 0.0);
	glColor3f(0.8,0.3,0.0);
    glColorMaterial(GL_FRONT, GL_EMISSION);
	glutSolidSphere(0.05,40,40);
    //glTranslatef(-0.35,0.0,0.3); 

  glPopMatrix();
  glutPostRedisplay();
  glutSwapBuffers ( );
                            

}

void reshape(int w, int h)
{
  glViewport(0, 0, w, h);
  setProjection();
}

void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
    case 27:
      exit (0);
      break;
    default:
      break;
  }
}

void menu(int value)
{
    switch (value) {
    case 'a':
		mod=PERSPEKTIVA;
	break;
    case 'b':
		mod=ROVNOBEZNE_PROMITANI;
	break;
    }
}

void idle(void)
{
   glutPostRedisplay();
}



int main(int argc, char* argv[])
{
  glutInit( &argc, argv );
  glutInitDisplayMode( GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE );
  glutInitWindowPosition(50, 50);
  glutInitWindowSize( 600, 500 );
  glutCreateWindow( "Uloha c.3 P009" );
  glutDisplayFunc( display );
  glutReshapeFunc( reshape );
  glutKeyboardFunc( keyboard );

  glutCreateMenu(menu);
  glutAddMenuEntry("Zmena kamery", 0);
  glutAddMenuEntry("", 0);
  glutAddMenuEntry("Kamera 1", 'b');
  glutAddMenuEntry("Kamera 2", 'a');
  glutAttachMenu(GLUT_RIGHT_BUTTON); 
  glutAttachMenu(GLUT_LEFT_BUTTON); 


  glutIdleFunc (idle);

  init ();
  glutMainLoop        ( );         

  return 0;
}
